{% block content %}

/*
вспомогательная функция вызова окна
 */

var privilegeField = Ext.getCmp('{{ component.field__privilege_id.client_id }}');
var privilegeReportTypeFields = Ext.util.JSON.decode('{{ component.privilege_report_type_fields|safe }}');
var report_type = parseInt('{{ component.privilege_report_type }}');
var dismissalDate = Ext.getCmp('{{ component.field__dismissal_date.client_id }}');

function showControlsByReportType(report_type) {
    for (var i in privilegeReportTypeFields) {
        Ext.each(privilegeReportTypeFields[i], function (item) {
            Ext.getCmp(item).hide();
        })
    }

    if (report_type) {
        Ext.each(privilegeReportTypeFields[report_type], function (item) {
            Ext.getCmp(item).show();
        });
    }
}

dismissalDate.on('show', function (cmp) {
   // {# Хак отображения кнопки выбора текущей даты, после показа компонента #}
   cmp.setWidth(cmp.getWidth() - 18);
});

showControlsByReportType(report_type);
privilegeField.on('change', function (cmp, value) {
    if (value) {
        Ext.Ajax.request({
            params: {'privilege_id': value},
            url: '{{ component.get_report_type_url }}',
            success: function (res, opt) {
                var obj = Ext.util.JSON.decode(res.responseText);
                showControlsByReportType(obj.report_type);
            },
            failure: uiAjaxFailMessage
        });
    } else {
        showControlsByReportType();
    }
});


win.actionContextJson.privilege_confirmation = false;
var cntxParams = win.actionContextJson;

function openWindow(url, params, close){
    Ext.applyIf(params, cntxParams);

    Ext.Ajax.request({
        url: url,
        method: 'POST',
        params: params,
        success: function (res, opt) {
            smart_eval(res.responseText);
            if (close) {
                win.close();
            }
        },
        failure: function (res, opt) {
            uiAjaxFailMessage();
        }
    });
}

var privilegeConfirmationURL = '{{ component.privilege_confirmation_url }}',
    privilegeConfirmationFlag = false,
    privilegeConfirmationStatus = Ext.getCmp(
        '{{ component.privilege_confirmation_status.client_id }}'),
    privilege = Ext.getCmp(
        '{{ component.field__privilege_id.client_id }}'),
    owner = Ext.getCmp(
        '{{ component.privilege_owner.client_id }}'),
    delegate = Ext.getCmp(
        '{{ component.delegate.client_id }}'),
    privilegeOrig = privilege.getValue(),
    ownerOrig = owner.getValue(),
    delegateOrig = delegate.getValue(),
    needDelegate = {{ component.NEED_DELEGATE|safe }},
    confirmPrivilegeButton = Ext.getCmp(
        '{{ component.confirm_privilege_button.client_id }}'),
    confirmed = '{{ component.PCS_YES }}',
    notConfirmed = '{{ component.PCS_NO }}';

function privilegeOwnerChange(){
    if (needDelegate.indexOf(owner.getValue()) >= 0  && is_created_child()) {
        delegate.show();
    } else {
        delegate.hide();
        delegate.setValue('');
    }

    if (owner.getValue() && is_created_child()) {
        confirmPrivilegeButton.enable();
    } else {
        confirmPrivilegeButton.disable();
    }
}

/* Возвращает:
true - если ребенок уже был создан,
а окно открыто при редактировании заявки;
false - если ребенок еще не создан,
а окно открыто при добавлении заявки
*/
function is_created_child(){
    return 'children_id' in win.actionContextJson
}

function privilegeConfirmationStatusChange(){
    if (privilegeOrig != privilege.getValue()){
        delegate.setValue('');
        owner.setValue('');
        privilegeConfirmationStatus.setValue(notConfirmed);
    } else {
        delegate.setValue(delegateOrig);
        owner.setValue(ownerOrig);
        privilegeConfirmationStatus.setValue(confirmed);
    }

    privilegeOwnerChange();
}

function afterSubmitForm(win, form, action){
    closeWindow = ! privilegeConfirmationFlag;

    if (privilegeConfirmationFlag) {
        privilegeConfirmationFlag = false;
        openWindow(privilegeConfirmationURL, {'parent_window_id': win.id}, false);
    };

    return closeWindow;
}

function privilegeConfirmation(){
    form = win.getForm()

    if (form.isDirty()) {
        Ext.Msg.show({
            title: 'Внимание',
            msg: String.format('Для подтверждения льготы необходимо сохранить ' +
                               'внесенные данные.<br/> Cделать это сейчас?'),
            icon: Ext.Msg.QUESTION,
            buttons: {
                yes : 'Сохранить и продолжить',
                no : 'Отменить и продолжить редактирование льготы'
            },
            modal: true,
            fn: function(btn, text, opt){if (btn == 'yes') {privilegeConfirmationPreSave();}}
        });
    } else {
        privilegeConfirmationPreSave();
    }
}

function privilegeConfirmationPreSave(btn, text, opt){
    privilegeConfirmationFlag = true;

    win.actionContextJson.privilege_confirmation = true;

    win.submitForm();
}

privilege.on('change', privilegeConfirmationStatusChange);
owner.on('select', privilegeOwnerChange);
win.on('aftersubmit', afterSubmitForm);

privilegeOwnerChange();

{% endblock %}
